<script type="text/javascript">
/* <![CDATA[ */
var BrowserDetect = {
	init: function () {
		this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
		this.version = this.searchVersion(navigator.userAgent)
			|| this.searchVersion(navigator.appVersion)
			|| "an unknown version";
		this.OS = this.searchString(this.dataOS) || "an unknown OS";
	},
	searchString: function (data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].string;
			var dataProp = data[i].prop;
			this.versionSearchString = data[i].versionSearch || data[i].identity;
			if (dataString) {
				if (dataString.indexOf(data[i].subString) != -1)
					return data[i].identity;
			}
			else if (dataProp)
				return data[i].identity;
		}
	},
	searchVersion: function (dataString) {
		var index = dataString.indexOf(this.versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	},
	dataBrowser: [
		{
			string: navigator.userAgent,
			subString: "Chrome",
			identity: "Chrome"
		},
		{ 	string: navigator.userAgent,
			subString: "OmniWeb",
			versionSearch: "OmniWeb/",
			identity: "OmniWeb"
		},
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: "Safari"
		},
		{
			prop: window.opera,
			identity: "Opera"
		},
		{
			string: navigator.vendor,
			subString: "iCab",
			identity: "iCab"
		},
		{
			string: navigator.vendor,
			subString: "KDE",
			identity: "Konqueror"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: "Firefox"
		},
		{
			string: navigator.vendor,
			subString: "Camino",
			identity: "Camino"
		},
		{		// for newer Netscapes (6+)
			string: navigator.userAgent,
			subString: "Netscape",
			identity: "Netscape"
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: "Explorer",
			versionSearch: "MSIE"
		},
		{
			string: navigator.userAgent,
			subString: "Gecko",
			identity: "Mozilla",
			versionSearch: "rv"
		},
		{ 		// for older Netscapes (4-)
			string: navigator.userAgent,
			subString: "Mozilla",
			identity: "Netscape",
			versionSearch: "Mozilla"
		}
	],
	dataOS : [
		{
			string: navigator.platform,
			subString: "Win",
			identity: "Windows"
		},
		{
			string: navigator.platform,
			subString: "Mac",
			identity: "Mac"
		},
		{
			string: navigator.platform,
			subString: "Linux",
			identity: "Linux"
		}
	]
};
BrowserDetect.init();
// returns true if MathPlayer is installed and can be instantiated

function isMPInstalled()
{
	try {
		var oMP = new ActiveXObject("MathPlayer.Factory.1");
		return true;
	}
	catch(e) {
		return false;
	}
}

function isMPPriorToCurrentInstalled()
{

	try {
			// detect all versions prior to the 2.1 beta
		if (navigator.appVersion.indexOf("MathPlayer 1.") != -1)
			return true;		
		if (navigator.appVersion.indexOf("MathPlayer 2.0") != -1)
			return true;
		return false;
	}
	catch(e) {
		return false;
	}
}

// returns True if running on any version of IE Windows
function isIEWindows()
{
	return( (navigator.appName=="Microsoft Internet Explorer") && 
		(navigator.appVersion.indexOf("Windows") != -1) );
}
function isFirefox()
{
	return( (BrowserDetect.browser=="Firefox") );
}
// returns version of Internet Explorer
function ieVersion()
{
	var ieVer = 0;
	var start = navigator.appVersion.indexOf("MSIE "); 
	if (start != -1) { 
		ieVer = parseFloat(navigator.appVersion.substring(start+5)); 
	}
	return ieVer;
}

function showHaveMP()
{
document.getElementById("MPInstalled").style.display = "block";
}

function showUpgradeMP()
{
	document.getElementById("MPUpgrade").style.display="block";
}

function showGetMP()
{
	document.getElementById("MPNotInstalled").style.display="block";
}


function showUpgradeMPUpgradeIE()
{
	document.getElementById("UpgradeMPUpgradeIE").style.display = "block";
}




// determines if MathPlayer is installed and up to date, displays appropriate
function check() {
  // first test platform, as the MathPlayer-specific code only works in IE
  if( isIEWindows()) {	
    if (ieVersion() >= 6.0) {
		if (isMPInstalled()) {     
			var start = navigator.appVersion.indexOf("MathPlayer");
			if (start != -1) { 
				if  (isMPPriorToCurrentInstalled())	{// have prior to 2.1
					showUpgradeMP();
					}
				else {
					showHaveMP(); // have MP 2, have IE6
					}
			}
			else {           
				showUpgradeMP();  // need MP upgrade, have IE6
			}
		}
		else {               
			showGetMP();  // need MP, have IE6
		}
    }
  }
  else {  
	if (isFirefox()){
		document.getElementById("firefox").style.display = "block";
	}
	else {
		document.getElementById("browserproblem").style.display = "block";
	}
  }
  document.getElementById("browsername").innerHTML = BrowserDetect.browser+" "+BrowserDetect.version;  

}
/* ]]> */

</script>
