#! /usr/bin/perl

#this reorganises the html to remove the frames layout

use strict;
use warnings;
use HTML::Entities;

use XML::Twig;
my $t= XML::Twig->new(twig_roots => { title => 1, span => 1 });
$t->parsefile('Notes/Notes2.xht');
$t->set_pretty_print ('indented');
my $root= $t->root;
my $title= $root->first_child( 'title'); # get the title
my $body= $root->first_child( 'body'); # get the title
# $body->set_tag( 'div');
# $body->set_att( 'id','left');
# my $menu=encode_entities($body->sprint,'^\n\x20-\x25\x27-\x7e');
# $menu=~ s/&amp;lt/&lt/g;
# $menu=~ s/&amp;gt/&gt/g;
# $menu=~ s/target="tex4ht-main"/target=_self/g;
# print $menu;
my @span= $root->children( 'span');

my %chaplist; # can have appendices, chapter *'s, ...
my @chaplabels=();
my @menu=();
my %menulist;
my $text;
my $curchap="";
my $chap;
foreach my $span (@span)
{
    $text=$span->sprint();
    $text=~ s/target="tex4ht-main"/target="_self"/g;
    if ($span->att('class') eq "chapterToc" or $span->att('class') eq "appendixToc"){
	$text =~ /[^>]*>(\w*)/;$chap=$1;
	$chaplist{$chap} = $text;
	push @chaplabels, $chap;
	if ($curchap ne "") {$menulist{$curchap}= [ @menu ]; @menu=();}
	$curchap=$chap;
    }
    elsif ($span->att('class') eq "likechapterToc")
	{ 
# delete
      }
    else {    push @menu, $text;}
#    print "$span->att('class')\n";
};
$menulist{$curchap}= [ @menu ];
#print @chaplist;
# for my $menuitem (@menulist){
#     print "MENU\n [ @$menuitem ] \n";
# }

my %menus;
my $nmenus= $#chaplabels;

print "Number of menu entries $nmenus\n";

my $home='<div class="menuhead">Navigation</div>
<div class="menusubhead"><div class="chapterToc"><a href="../../">home</a></div></div>
<div class="menusubhead"><div class="chapterToc"><a href="./">Notes</a></div></div>';
my $chapmenu= encode_entities(join("\n",  $home, @chaplist{ @chaplabels}),'^\n\x20-\x25\x27-\x7e');
$chapmenu =~ s/span/div/g;

my $tmp;

for my $i (0..$nmenus-1) {
    $tmp =encode_entities(join("\n",  $home, @chaplist{ @chaplabels[0 .. $i] } , @{$menulist{$chaplabels[$i]}}, @chaplist{@chaplabels[$i+1 .. $nmenus]}),'^\n\x20-\x25\x27-\x7e');
    $tmp =~ s/span/div/g;
    $menus{$chaplabels[$i]}=$tmp;
}


$tmp=encode_entities( join("\n",  $home, @chaplist{@chaplabels}, @{$menulist{$chaplabels[$nmenus]}} ),'^\n\x20-\x25\x27-\x7e');
$tmp =~ s/span/div/g;
$menus{$chaplabels[$nmenus]}=$tmp;

#print $menus[0];

#system("rm Notes/Notes2.xht");

my $now=gmtime();

my @list=qx'ls Notes/Notesse*xht';
my $f;
 $t= XML::Twig->new(twig_roots => { title => 1, body => 1});
foreach $f (@list) {
    chomp($f);
    print "now: $f\n";
# now extract menu, and apply template; 
#Notes2: menu
#Notes3: start page
#Notesch...: other pages
#extract body from menu
# extract title and body from any other page
# wrap body in <div class="content">
# voila!use XML::Parser;
    $t->parsefile($f);
    $root= $t->root;
    my $title= $root->first_child( 'title'); # get the title
    my $titext=$title->inner_xml();
    my $body= $root->first_child( 'body'); # get the title
    $body->set_tag( 'div');
    $body->set_att( 'id','center');
#    my $content=Encode::decode('iso-8859-1',$body->sprint);
    my $content=encode_entities($body->sprint,'^\n\x20-\x25\x27-\x7e');

    $content =~ /\"titlemark\">\s*(\d\d|\d|[A-Z])/;
    my $sec=$1;
    $content=~ s/&amp;lt/&lt/g;
    $content=~ s/&amp;gt/&gt/g;
    open(IN,"<template");
    open(OUT,">$f");
    $^I = '';
    while ( <IN> ) {
	s|%title%|$titext|;
	s|%body%|$content|;
	s|%menu%|<div class="menu">$menus{$sec}</div>|;
	s|%date%|$now|;
	s|>([a-zA-Z0-9])|> $1|g;
	print OUT $_;
    }
    close(IN);    
    close(OUT);    
}

@list=qx'ls Notes/Notesch*xht Notes/Notesap*xht Notes/Notes3.xht';
foreach $f (@list) {
    print "now: $f\n";
# now extract menu, and apply template; 
#Notes2: menu
#Notes3: start page
#Notesch...: other pages
#extract body from menu
# extract title and body from any other page
# wrap body in <div class="content">
# voila!use XML::Parser;
    $t->parsefile($f);
    $root= $t->root;
    my $title= $root->first_child( 'title'); # get the title
    my $titext=$title->inner_xml();
    my $body= $root->first_child( 'body'); # get the title
    $body->set_tag( 'div');
    $body->set_att( 'id','center');
#    my $content=Encode::decode('iso-8859-1',$body->sprint);
    my $content=encode_entities($body->sprint,'^\n\x20-\x25\x27-\x7e');

    $content =~ /\"titlemark\">(Chapter&\#x00A0;(\d\d|\d)|Appendix&\#x00A0;([A-Z])|(\d\d|\d|[A-Z]))/;
#    $content =~ /\"titlemark\">[^<^\d]*(\d\d|\d)</;
    my $sec=$2;
#    print "$f is chapter: $sec\n";
    $content=~ s/&amp;lt/&lt/g;
    $content=~ s/&amp;gt/&gt/g;
    open(IN,"<template");
    open(OUT,">$f");
    $^I = '';
    while ( <IN> ) {
	s|%title%|$titext|;
	s|%body%|$content|;
	if (defined($sec) && $sec>1) {	
	    s|%menu%|<div class="menu">$menus{$sec}</div>|;
	} else {
	    s|%menu%|<div class="menu">$chapmenu</div>|;
	}
	s|%date%|$now|;
	s|>([a-zA-Z0-9])|> $1|g;
	print OUT $_;
    }
    close(IN);    
    close(OUT);    
}
sub slurp
	{
	my $inf;
	my $ouf;
	my $holdTerminator = $/;
	undef $/;
	open $inf, "<$_[0]";
	my $buf = <$inf>;
	close $inf;
	$/ = $holdTerminator;
	my @lines = split /$holdTerminator/, $buf;
	$buf = "init";
	$buf = join $holdTerminator, @lines;
	return $buf;
	}

#system ("cp  Notes/Notes3.xht Notes/index.html");

my $hin=slurp("insert.header");
my $bin=slurp("insert.body");
open(IN,"<Notes/Notes3.xht");
open(OUT,">Notes/index.html");
$^I = '';
while ( <IN> ) {
    s|<title> text|<title> Notes|g;
    s|title"> text|title"> Notes|g;
    s|</head>|$hin</head>|g;
    s|<div id=\"footer|<!-- xxxxxxxxxxxx>\n$bin\n<div id=\"footer|g;
    print $_;
    print OUT $_;
}
close(IN);    
close(OUT);    
